//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "TableCopy.h"
//---------------------------------------------------------------------------
static inline TTableCopy *ValidCtrCheck()
{
	return new TTableCopy(NULL);
}
//---------------------------------------------------------------------------
__fastcall TTableCopy::TTableCopy(TComponent* Owner)
	: TComponent(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTableCopy::Notification(TComponent* AComponent, TOperation Operation)
{
if ((AComponent == FSource) && (Operation == opRemove)) FSource = NULL;
if ((AComponent == FDestination) && (Operation == opRemove)) FDestination = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TTableCopy::SetSource(TDataSet *ADataSet)
{
// source and destination must be different
if (ADataSet == FDestination) FSource = NULL;
else FSource = ADataSet;
}
//---------------------------------------------------------------------------
void __fastcall TTableCopy::SetDestination(TDataSet *ADataSet)
{
// source and destination must be different
if (ADataSet == FSource) FDestination = NULL;
else FDestination = ADataSet;
}
//---------------------------------------------------------------------------
bool __fastcall TTableCopy::Execute()
{
// make index of matching fields
int FieldIndexArray[256][2];
for (int i = 0; i < 256; i++)
    FieldIndexArray[i][0] = -1;
FMatches = 0;
for (int i = 0; i < FSource->FieldCount; i++)
	{
    int j = 0;
    while (j < FDestination->FieldCount)
    	{
        if (FSource->Fields[i]->FieldName == FDestination->Fields[j]->FieldName)
        	{
            FMatches++;
            FieldIndexArray[i][0] = i;
            FieldIndexArray[i][1] = j;
            break;
            }
        j++;
        }
    }

if (FMatches == 0) return false;
// copy data
FSource->First(); FDestination->First();
while (!FSource->Eof)
	{
    FDestination->Insert();
    for (int j = 0; j < FSource->FieldCount; j++)
    	{
        if (FieldIndexArray[j][0] != -1)
        	{
            FDestination->Fields[FieldIndexArray[j][1]]->Value =
          		FSource->Fields[FieldIndexArray[j][0]]->Value;
            }
        }
    FSource->MoveBy(1);
    FDestination->Post();
    FDestination->MoveBy(1);
    }
return true;
}
//---------------------------------------------------------------------------
namespace Tablecopy
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TTableCopy)};
		RegisterComponents("Samples", classes, 0);
	}
}
//---------------------------------------------------------------------------
